NEURON {
	ARTIFICIAL_CELL IntISI
	RANGE tau, refrac, m, ifthresh
}

PARAMETER {
	tau = 10 (ms)
	refrac = 10 (ms)
	ifthresh = 0.5
}

ASSIGNED {
	j
	m
	t0(ms)
	refractory
}

INITIAL {
	j = 0
	m = 0
	t0 = t
	refractory = 0 : 0-integrates input, 1-small refractory, 2-big refractory
}

FUNCTION M() {
	if (refractory == 0) {
		M = m*exp(-(t - t0)/tau)
	}else if (refractory == 1) {
		if (t - t0 < .1) {
			M = 2.3 * ifthresh
		}else{
			M = -0.1
		}
	}
}

NET_RECEIVE (w) {
if (refractory == 0) { : inputs integrated only when excitable
		m = m*exp(-(t - t0)/tau)
		t0 = t
		m = m + w
		if (m > ifthresh) {
			refractory = 1
			m = 2
			j = j+1
				if (j == 1){
				net_send(.0002/w, refractory)
				net_event(t)
			}else if (j == 2){
				net_send(refrac - .0002/w, refractory)
				net_event(t)
				j = 0
			}
		}
	}else if (flag == 1) { : ready to integrate again
		t0 = t
		refractory = 0
		m = 0
	}
}
